#
# spec file for package qt (Version 4.3.4)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           qt
BuildRequires:  Mesa-devel cups-devel freetype2-devel gcc-c++ libjpeg-devel libmng-devel openssl-devel
BuildRequires:  glib2-devel libpng-devel libtiff-devel pkgconfig
%if 0%{?suse_version}
BuildRequires:  update-desktop-files
%endif
%if %suse_version > 910
BuildRequires:  dbus-1-devel xorg-x11-devel
%else
BuildRequires:  XFree86-devel XFree86-libs
%endif
BuildRequires:  openssl-devel
%if %suse_version > 1020
BuildRequires:  fdupes
%endif
Url:            http://www.trolltech.com
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          System/Libraries
AutoReqProv:    on
Summary:        C++ Program Library, Core Components
# COMMON-BEGIN
Version:        4.3.4
Release:        0.7.1
%define x11_free  -x11-opensource-src-
%define rversion 4.3.4
Source:         qt%x11_free%{rversion}_crippled.tar.bz2
Source10:       qt4config.desktop
Source11:       designer4.desktop
Source12:       linguist4.desktop
Source13:       assistant4.desktop
Source14:       assistant.png
Source15:       designer.png
Source16:       linguist.png
Source99:       cripple_tarball.sh
Patch2:         qt-never-strip.diff
Patch3:         plastik-default.diff
Patch5:         lib64.patch
Patch6:         use-freetype-default.diff
Patch7:         FIXME.diff
Patch8:         link-tools-shared.diff
Patch21:        0142-uic3-wordWrapAttribute.diff
Patch20:        qt-font-choose.diff
Patch24:        qt4-pedantic-headers.diff
Patch25:        qtextedit-capitalization.diff
Patch27:        0167-fix-group-reading.diff
Patch29:        0178-transparency-window-types.diff
Patch30:        0179-transient-hack.diff
Patch31:        0180-window-role.diff
Patch39:        0191-listview-alternate-row-colors.diff
Patch40:        0188-fix-moc-parser-same-name-header.diff
Patch41:        0189-fix-q3toolbar-qcombobox-signal-slot.diff
Patch43:        qdbus-enable-on-sles10.diff
Patch47:        0200-fix-qsslsocket-waitfor.diff
Patch50:        gcc-43-warnings.diff
Patch51:        CVE-2009-2700.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define common_options -fast -no-separate-debug-info -shared -xkb -tablet -xrender -xrandr -xinerama -sm -no-nas-sound -no-rpath -system-libjpeg -system-libpng -accessibility -cups -stl -nis -system-zlib -qt-gif -prefix /usr -L %_libdir -libdir %_libdir -docdir %_docdir/qt -examplesdir %_docdir/qt/examples -demosdir %_libdir/qt/demos -plugindir %plugindir -translationdir /usr/share/qt/translations -iconv -sysconfdir /etc/settings -datadir /usr/share/qt/ -no-pch -reduce-relocations -no-exceptions -system-libtiff -glib -qdbus -openssl

%description
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.



Authors:
--------
    Troll Tech AS, Norway

%if 0%{?opensuse_bs}
%endif

%prep
%define plugindir %_libdir/qt/plugins
%setup -q -n qt%x11_free%{rversion}_crippled
%patch2
%patch3
%patch5
%patch6
%patch7
%patch8
%patch21
%patch24
%patch25
%patch27
%patch29
%patch30
%patch31
%patch39
%patch40
%patch41
%if %suse_version < 1020
%patch43
%endif
%patch47
%patch50
%patch51
# be sure not to use them
rm -rf src/3rdparty/{libjpeg,freetype,libpng,zlib,libtiff}
echo "Please use qt-devel now." > README.dbus-1-qt-devel
# COMMON-END

%package -n dbus-1-qt-devel
License:        Other uncritical OpenSource License
Summary:        Developer package for D-BUS/QT bindings
Group:          Development/Libraries/KDE
Requires:       %name-devel = %version

%description -n dbus-1-qt-devel
D-BUS is a message bus system, a simple way for applications to talk to
one another. D-BUS supplies both a system daemon (for events such as
"new hardware device added" or "printer queue changed") and a
per-user-login-session daemon (for general IPC needs among user
applications). Also, the message bus is built on top of a general
one-to-one message passing framework, which can be used by any two apps
to communicate directly (without going through the message bus daemon).



Authors:
--------
    Olivier Andrieu <oliv__a@users.sourceforge.net>
    Philip Blundell <pb@nexus.co.uk>
    Anders Carlsson <andersca@gnome.org>
    Kristian Hogsberg  <krh@redhat.com>
    Alex Larsson <alexl@redhat.com>
    Michael Meeks <michael@ximian.com>
    Seth Nickell <seth@gnome.org>
    Havoc Pennington <hp@redhat.com>
    Harri Porten <porten@kde.org>
    Matthew Rickard <mjricka@epoch.ncsc.mil>
    Zack Rusin <zack@kde.org>
    Joe Shaw <joe@assbarn.com>
    Colin Walters <walters@gnu.org>
    David Zeuthen <david@fubar.dk>

%package devel
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          Development/Libraries/X11
Summary:        Qt Development Kit
Requires:       zlib-devel c++_compiler pkgconfig glib2-devel
Requires:       freetype2-devel libmng-devel libpng-devel libtiff-devel
%if %suse_version > 910
Requires:       xorg-x11-devel dbus-1-devel
%else
Requires:       XFree86-devel
%endif
%if %suse_version > 910
Requires:       Mesa-devel openssl-devel
%endif
Requires:       %name = %version

%description devel
You need this package, if you want to compile programs with Qt. It
contains the "Qt Crossplatform Development Kit". It does contain
include files and development applications like GUI designers,
translator tools and code generators.



Authors:
--------
    Troll Tech AS, Norway

%package -n dbus-1-qt
License:        Other uncritical OpenSource License
Group:          Development/Libraries/KDE
Summary:        QT4/KDE bindings for D-BUS
Requires:       %name = %version

%description -n dbus-1-qt
QT4/KDE bindings for D-BUS



Authors:
--------
    Olivier Andrieu <oliv__a@users.sourceforge.net>
    Philip Blundell <pb@nexus.co.uk>
    Anders Carlsson <andersca@gnome.org>
    Kristian Hogsberg  <krh@redhat.com>
    Alex Larsson <alexl@redhat.com>
    Michael Meeks <michael@ximian.com>
    Seth Nickell <seth@gnome.org>
    Havoc Pennington <hp@redhat.com>
    Harri Porten <porten@kde.org>
    Matthew Rickard <mjricka@epoch.ncsc.mil>
    Zack Rusin <zack@kde.org>
    Joe Shaw <joe@assbarn.com>
    Colin Walters <walters@gnu.org>
    David Zeuthen <david@fubar.dk>

%package devel-doc
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          Documentation/HTML
Summary:        Qt documentation
Requires:       %name = %version
Requires:       %name-devel-doc-data = %version

%description devel-doc
The package contains documentation and examples to develop Qt
applications. The SuSE help provides a search function for this
documentation. The package includes also a tutorial and examples.



Authors:
--------
    Troll Tech AS, Norway

%package x11
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          Development/Libraries/C and C++
Summary:        Qt 4 GUI related libraries
Requires:       %name = %version

%description x11
Qt 4 libraries which are used for drawing widgets and OpenGL items.



Authors:
--------
    Troll Tech AS, Norway

%package qt3support
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          System/Libraries
Summary:        C++ Program Library, Core Components
Requires:       %name = %version

%description qt3support
Qt is a set of libraries for developing applications.

This package contains base tools, like string, xml, and network
handling.



Authors:
--------
    Troll Tech AS, Norway

%package sql
License:        GPL v2 or later; THE Q PUBLIC LICENSE (QPL)
Group:          Development/Libraries/C and C++
Summary:        Qt 4 SQL related libraries
Requires:       %name = %version

%description sql
Qt 4 libraries which are used for connection with an SQL server. You
will need also a plugin package for a supported SQL server.



Authors:
--------
    Troll Tech AS, Norway

%build
export QTDIR=$PWD
export PATH=$PWD/bin:$PATH
export LD_LIBRARY_PATH=$PWD/lib/
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
sed -i -e "s,^\(CXXFLAGS[ \t]*=.*\),\1 $RPM_OPT_FLAGS," qmake/Makefile.unix
export CXXFLAGS="$CXXFLAGS $RPM_OPT_FLAGS"
export CFLAGS="$CFLAGS $RPM_OPT_FLAGS"
echo yes | ./configure %common_options -no-sql-sqlite -no-sql-sqlite2
make %{?jobs:-j %jobs}

%install
make INSTALL_ROOT=$RPM_BUILD_ROOT install
# argggh, qmake is such a piece of <censored>
find $RPM_BUILD_ROOT/%_libdir -type f -name '*prl' -exec perl -pi -e "s, -L$RPM_BUILD_DIR/\S+,,g" {} \;
find $RPM_BUILD_ROOT/%_libdir -type f -name '*prl' -exec sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" {} \;
find $RPM_BUILD_ROOT/%_docdir/%name -type f -name 'lib*.a' -exec rm {} \;
find $RPM_BUILD_ROOT/%_libdir -type f -name '*la' -print -exec perl -pi -e "s, -L$RPM_BUILD_DIR/?\S+,,g" {} \;
# insanity ...
find $RPM_BUILD_ROOT/%_libdir -type f -name '*pc' -print -exec perl -pi -e "s, -L$RPM_BUILD_DIR/?\S+,,g" {} \; -exec sed -i -e "s,^moc_location=.*,moc_location=/usr/bin/moc," -e "s,uic_location=.*,uic_location=/usr/bin/uic," {} \;
find $RPM_BUILD_ROOT/%_libdir/ -name 'lib*.a' -exec chmod -x -- {} \;
mkdir -p $RPM_BUILD_ROOT/%plugindir/sqldrivers
if test -f changes-*; then
  cp -a changes-* \
      $RPM_BUILD_ROOT/usr/share/doc/packages/%name/
fi
ln -s %_libdir/qt/demos $RPM_BUILD_ROOT/%_docdir/%name/demos
# clean up the mental derangement
%if %suse_version > 1020
for f in $RPM_BUILD_ROOT/usr/include/Qt*/*; do
  if test -f $f -a $(wc -l < $f) -eq 1; then
    incfile=$(cut -d'"' -f2 $f)
    cp -a $(dirname $f)/$incfile $f
  fi
done
fdupes -q -r -1  $RPM_BUILD_ROOT/usr/include/ | \
  sed -e "s,$RPM_BUILD_ROOT,," | \
  while read target rest; do
    for f in $rest; do
      ln -sf $target $f
  done
done
%endif
# packaged in libqt4-devel-doc-data
rm -rf $RPM_BUILD_ROOT/%_docdir/%name/{html,examples}
# some packages expect these symlinks
ln -s /usr/include/Qt $RPM_BUILD_ROOT/usr/share/qt/include
ln -s %_libdir $RPM_BUILD_ROOT/usr/share/qt/%_lib
#
# install menu entries
#
%suse_update_desktop_file -i qt4config  Qt Utility     DesktopSettings
%suse_update_desktop_file -i assistant4 Qt Development Documentation
%suse_update_desktop_file -i designer4  Qt Development GUIDesigner
%suse_update_desktop_file -i linguist4  Qt Development Translation
%if %suse_version > 1020
%fdupes -s $RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post 
/sbin/ldconfig -n %_libdir

%post devel
/sbin/ldconfig -n %_libdir

%post x11
/sbin/ldconfig -n %_libdir

%post qt3support
/sbin/ldconfig -n %_libdir

%post sql
/sbin/ldconfig -n %_libdir

%post -n dbus-1-qt
/sbin/ldconfig -n %_libdir

%postun -n dbus-1-qt
/sbin/ldconfig -n %_libdir

%postun
/sbin/ldconfig -n %_libdir

%postun devel
/sbin/ldconfig -n %_libdir

%postun x11
/sbin/ldconfig -n %_libdir

%postun qt3support
/sbin/ldconfig -n %_libdir

%postun sql
/sbin/ldconfig -n %_libdir

%files
%defattr(-,root,root,755)
%dir %_libdir/qt
%dir %plugindir
%dir /usr/share/qt
%dir /usr/share/doc/packages/%name
/usr/share/doc/packages/%name/changes-*
%_libdir/libQtCore*.so.*
%_libdir/libQtNetwork*.so.*
%_libdir/libQtXml*.so.*
%_libdir/libQtTest.so.*
/usr/share/qt/phrasebooks
/usr/share/qt/translations

%files x11
%defattr(-,root,root,755)
%exclude %plugindir/accessible/libqtaccessiblecompatwidgets.so
/usr/bin/qtconfig
/usr/bin/qdbusviewer
/usr/share/applications/qt4config.desktop
# designer.png is referenced by qt4config.desktop
%if %suse_version > 910
/usr/share/pixmaps/designer.png
%endif
%_libdir/libQtGui*.so.*
%if %suse_version > 910
%_libdir/libQtOpenGL*.so.*
%endif
%_libdir/libQtSvg.so.*
%_libdir/libQtScript.so.*
%_libdir/libQtDesigner*.so.*
%_libdir/libQtAssistantClient.so.*
%plugindir/codecs
%plugindir/iconengines
%plugindir/imageformats
%plugindir/inputmethods
%plugindir/accessible

%files qt3support
%defattr(-,root,root,755)
%_libdir/libQt3Support*.so.*
%plugindir/accessible/libqtaccessiblecompatwidgets.so

%files -n dbus-1-qt
%defattr(-,root,root,755)
/usr/bin/qdbus
%_libdir/libQtDBus*.so.*

%files -n dbus-1-qt-devel
%defattr(-,root,root,755)
%doc README.dbus-1-qt-devel

%files devel
%defattr(-,root,root,755)
/usr/bin/rcc
/usr/bin/uic
/usr/bin/uic3
/usr/bin/moc
/usr/bin/qmake
/usr/bin/designer
/usr/bin/linguist
/usr/bin/lrelease
/usr/bin/lupdate
/usr/bin/pixeltool
/usr/bin/qt3to4
%if %suse_version > 910
/usr/bin/qdbuscpp2xml
/usr/bin/qdbusxml2cpp
%endif
%_libdir/lib*.prl
%_libdir/lib*a
%_libdir/lib*.so
%_libdir/pkgconfig/*
%plugindir/designer
/usr/include/*
/usr/share/applications/designer4.desktop
/usr/share/applications/linguist4.desktop
%if %suse_version > 910
/usr/share/pixmaps/linguist.png
%endif
/usr/share/qt/include
/usr/share/qt/%_lib
/usr/share/qt/mkspecs
/usr/share/qt/q3porting.xml

%files devel-doc
%defattr(-,root,root,755)
/usr/bin/assistant
/usr/bin/qtdemo
%if %suse_version > 910
/usr/share/pixmaps/assistant.png
%endif
/usr/share/applications/assistant4.desktop
/usr/%_lib/qt/demos
%_docdir/%name/demos

%files sql
%defattr(-,root,root,755)
%dir %plugindir/sqldrivers
%_libdir/libQtSql*.so.*

%changelog
* Sat Oct 31 2009 dmueller@suse.de
- fix null byte injection in SAN parsing (CVE-2009-2702, bnc#534081)
* Tue Feb  3 2009 dmueller@suse.de
- reintroduce dropped dbus-1-qt-devel package (bnc#455998)
* Wed Feb 27 2008 dmueller@suse.de
- update to 4.3.4 (fate #302897):
  * for detailed changelog, see included changes-4.3.4
* Tue Jan 15 2008 dmueller@suse.de
- always buildrequire openssl
* Wed Jan  9 2008 dmueller@suse.de
- update to 4.3.3 (fate #302897):
  * for changelog, see included changes-4.3.3
* Fri Mar 30 2007 dmueller@suse.de
- add patch for utf8 decoder compliance issue
  (#259187, CVE-2007-0242)
* Thu Oct 19 2006 dmueller@suse.de
- add patch for integer overflow in QPixmap/QImage
  (#212544, CVE-2006-4811)
* Tue Jul 18 2006 dmueller@suse.de
- Install QtUiTools (#189163)
* Mon Apr 10 2006 dmueller@suse.de
- fix wrong assembler mnemonic in QAtomic for s390x
* Wed Mar 22 2006 dmueller@suse.de
- fix debug package conflict
* Tue Mar 21 2006 dmueller@suse.de
- don't build the examples against debug libs
- fix plugin loading (#159092)
* Wed Mar  1 2006 dmueller@suse.de
- strip $RPM_BUILD_DIR from installed files (#153597)
* Fri Feb 17 2006 dmueller@suse.de
- install arthurplugin into plugin designer path (#151529)
- add patch to make parallel builds work
- enable parallel builds
* Wed Feb 15 2006 dmueller@suse.de
- Fix qt-devel requires
- Add patch to make it usable for KDE 4
* Sun Feb 12 2006 stbinner@suse.de
- fix build
* Sun Feb 12 2006 ro@suse.de
- fix spec file
* Wed Feb  8 2006 dmueller@suse.de
- build qt-sql in qt.spec, and only the plugins separate
* Fri Feb  3 2006 aj@suse.de
- Reduce BuildRequires.
* Wed Feb  1 2006 dmueller@suse.de
- remove no-visibility patch. Qt now builds fine with it
- remove no_rpath patch and instead use -no-rpath configure option
- split source package
- add upstream patch to fix license display in Qt dialog boxes
  (#146599)
* Tue Jan 31 2006 dmueller@suse.de
- fix qt-qt3support / qt-devel file conflict
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Dec 20 2005 dmueller@suse.de
- update to Qt 4.1 final
- add ldconfig post/postun for qt3support
* Wed Dec  7 2005 uli@suse.de
- atomic-s390.patch has been merged into 4.1, applying it again
  breaks build; removed
- change X keysyms include order to avoid double definitions
* Tue Nov 22 2005 stbinner@suse.de
- update to Qt 4.1 RC 1
* Thu Nov 17 2005 dmueller@suse.de
- fix build for 9.1, 9.2
* Wed Sep 28 2005 dmueller@suse.de
- fix upgrade path (unpacking symlinks over dirs doesn't work)
* Sat Sep 17 2005 dmueller@suse.de
- add patch to make input methods work (#116778)
* Sat Sep 17 2005 dmueller@suse.de
- fix build for older distro's
* Thu Sep  8 2005 dmueller@suse.de
- fix qtdemo (#113783)
* Thu Sep  8 2005 adrian@suse.de
- do not disable STL support, which would make us incompatible
* Thu Sep  1 2005 dmueller@suse.de
- fix filelist
* Mon Aug 29 2005 adrian@suse.de
- do not do a parallel build, it does fail too often
* Tue Aug 23 2005 dmueller@suse.de
- fix filelist
- fix pkgconfig location
- remove BUILD-dirs from pkgconfig files
* Mon Aug 22 2005 dmueller@suse.de
- 4.0.1 update (bugfixes)
- add -debug subpackage
* Fri Aug 12 2005 dmueller@suse.de
- fix dependency of devel package
- fix doc packaging
- fix permissions
- add hack to fix the .la files produced by qmake
* Sun Aug  7 2005 adrian@suse.de
- link against external sqlite
- fix -devel package requires
* Sat Aug  6 2005 adrian@suse.de
- add desktop files for gui applications
* Mon Jul 11 2005 schwab@suse.de
- Fix ia64 atomic ops.
* Tue Jul  5 2005 uli@suse.de
- fixed semantics of atomic ops for s390* (tested and working)
* Wed Jun 29 2005 dmueller@suse.de
- reapply lost ia64 fixes
- build with -release only
* Wed Jun 29 2005 uli@suse.de
- fixed to build on lib64 archs
- squelched warnings that offend autobuild
- added atomic ops for s390*
* Tue Jun 28 2005 dmueller@suse.de
- upgrade Qt 4.0 final
* Fri Jun 17 2005 dmueller@suse.de
- some more rpmlint fixes and one ia64 fix.
* Wed Jun 15 2005 dmueller@suse.de
- build
* Tue Jun 14 2005 dmueller@suse.de
- fix packaging
* Tue Jun 14 2005 dmueller@suse.de
- update to 4.0.0rc1
* Thu May 12 2005 ro@suse.de
- fix build on x86-64 fix build on x86-64
* Wed Apr 13 2005 adrian@suse.de
- update to beta2
- rename qt-qt3compat package to qt-qt3support to follow library name
* Wed Jan  5 2005 adrian@suse.de
- update to pre beta2 snapshot 200513
  * package is under GPL/QPL again
- split package into sub packages
  * qt           - does not require any X11 or image lib dependency
  * qt-x11       - does need libX11 and OpenGL
  * qt-qt3compat - library for easy porting of Qt 3 code
  * qt-devel     - all development stuff
  * qt-devel-doc - API documentation and assistant tool
  * qt-sql*      - SQL database lib and plugins
* Fri Jul  9 2004 adrian@suse.de
- initial package of the new, great, perfect designed Qt 4
- internal package only for now
